package de.lmu.ifi.dbs.mmmog.tutorial03;

import java.util.*;

/**
 * Created by schmoll on 4/30/18.
 */
public class Cluster implements Iterable<DataPoint> {

    private final Set<DataPoint> points;

    public Cluster(Collection<DataPoint> points) {
        this.points = new HashSet<>(points);
    }

    public Cluster() {
        this.points = new HashSet<>();
    }


    @Override
    public Iterator<DataPoint> iterator() {
        return points.iterator();
    }

    public void addDataPoint(DataPoint point) {
        this.points.add(point);
    }

//    protected void print() {
//        System.out.println(Arrays.toString(new ArrayList<>(points).toArray()));
//    }

    @Override
    public int hashCode() {
        return points.hashCode();
    }

    @Override
    public boolean equals(Object o) {
        if (o != null && o.getClass() == getClass()) {
            return points.equals(((Cluster)o).points);
        }
        return false;
    }
}
