package de.lmu.ifi.dbs.mmmog.tutorial03;

/**
 * Class that represents a data point.
 *
 * @author Sebastian Schmoll
 */
public class DataPoint {

    private final double x;
    private final double y;

    public DataPoint(double x, double y) {
        this.x = x;
        this.y = y;
    }

    public double getY() {
        return y;
    }

    public double getX() {
        return x;
    }

    @Override
    public int hashCode() {
        return (int)Double.doubleToLongBits(x*y);
    }

    @Override
    public boolean equals(Object o) {
        if (o != null && getClass().equals(o.getClass())) {
            DataPoint p = (DataPoint)o;
            return x == p.x && y == p.y;
        }
        return false;
    }

    @Override
    public String toString() {
        return "new DataPoint("+x+","+y+")";
    }
}
