package de.lmu.ifi.dbs.mmmog.tutorial03;

import org.junit.Before;
import org.junit.Test;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;
import static org.junit.Assert.*;

/**
 * Test case for the Clustering Variance Minimization algorithm.
 *
 * @author Sebastian Schmoll
 */
public class ClusteringVarianceMinimizationTest {

    Set<Cluster> cluster5 = new HashSet<>(Arrays.asList(
            new Cluster(Arrays.asList(new DataPoint(7.1,3.0), new DataPoint(7.6,3.0), new DataPoint(7.0,3.2), new DataPoint(7.2,3.0), new DataPoint(7.7,3.0), new DataPoint(7.2,3.2), new DataPoint(7.7,3.8), new DataPoint(6.8,3.2), new DataPoint(6.9,3.2), new DataPoint(7.3,2.9), new DataPoint(7.2,3.6), new DataPoint(7.7,2.6), new DataPoint(7.9,3.8), new DataPoint(6.9,3.1), new DataPoint(7.7,2.8), new DataPoint(7.4,2.8))),
            new Cluster(Arrays.asList(new DataPoint(6.3,2.5), new DataPoint(6.5,2.8), new DataPoint(6.6,3.0), new DataPoint(6.0,2.9), new DataPoint(6.0,3.4), new DataPoint(6.1,3.0), new DataPoint(6.5,3.0), new DataPoint(6.0,3.0), new DataPoint(6.7,2.5), new DataPoint(6.8,3.0), new DataPoint(6.5,3.2), new DataPoint(6.7,3.0), new DataPoint(5.9,3.0), new DataPoint(6.0,2.7), new DataPoint(6.4,3.2), new DataPoint(6.1,2.8), new DataPoint(6.4,2.8), new DataPoint(6.3,3.4), new DataPoint(6.2,3.4), new DataPoint(6.7,3.1), new DataPoint(6.3,2.3), new DataPoint(6.3,2.9), new DataPoint(6.2,2.9), new DataPoint(6.6,2.9), new DataPoint(6.7,3.3), new DataPoint(6.2,2.8), new DataPoint(6.3,2.8), new DataPoint(6.4,3.1), new DataPoint(6.3,3.3), new DataPoint(6.8,2.8), new DataPoint(6.3,2.7), new DataPoint(6.4,2.7), new DataPoint(6.2,2.2), new DataPoint(5.9,3.2), new DataPoint(6.1,2.9), new DataPoint(6.4,2.9), new DataPoint(6.1,2.6))),
            new Cluster(Arrays.asList(new DataPoint(5.0,3.4), new DataPoint(5.1,3.5), new DataPoint(5.0,3.6), new DataPoint(4.8,3.0), new DataPoint(4.3,3.0), new DataPoint(5.0,3.0), new DataPoint(5.0,3.2), new DataPoint(5.0,3.5), new DataPoint(4.5,2.3), new DataPoint(5.0,3.3), new DataPoint(4.9,3.0), new DataPoint(4.4,3.0), new DataPoint(4.8,3.4), new DataPoint(5.2,3.4), new DataPoint(4.7,3.2), new DataPoint(5.1,3.3), new DataPoint(4.6,3.1), new DataPoint(4.4,2.9), new DataPoint(4.4,3.2), new DataPoint(5.1,3.4), new DataPoint(4.8,3.1), new DataPoint(4.9,3.1), new DataPoint(4.6,3.6), new DataPoint(4.6,3.2), new DataPoint(4.6,3.4))),
            new Cluster(Arrays.asList(new DataPoint(5.0,2.0), new DataPoint(5.5,2.3), new DataPoint(5.6,3.0), new DataPoint(5.6,2.5), new DataPoint(5.5,2.4), new DataPoint(5.5,2.5), new DataPoint(5.0,2.3), new DataPoint(5.1,2.5), new DataPoint(4.9,2.5), new DataPoint(5.7,2.5), new DataPoint(6.0,2.2), new DataPoint(5.5,2.6), new DataPoint(5.7,3.0), new DataPoint(5.4,3.0), new DataPoint(5.8,2.7), new DataPoint(5.2,2.7), new DataPoint(5.7,2.8), new DataPoint(4.9,2.4), new DataPoint(5.7,2.6), new DataPoint(5.6,2.8), new DataPoint(5.8,2.6), new DataPoint(5.6,2.9), new DataPoint(5.6,2.7), new DataPoint(5.8,2.8), new DataPoint(5.7,2.9))),
            new Cluster(Arrays.asList(new DataPoint(5.8,4.0), new DataPoint(5.2,3.5), new DataPoint(5.5,3.5), new DataPoint(5.5,4.2), new DataPoint(5.4,3.9), new DataPoint(5.7,3.8), new DataPoint(5.2,4.1), new DataPoint(5.4,3.7), new DataPoint(5.7,4.4), new DataPoint(5.1,3.7), new DataPoint(5.1,3.8), new DataPoint(5.4,3.4), new DataPoint(5.3,3.7)))
    ));


    Dataset iris;

    @Before
    public void setUp() throws Exception {
        List<DataPoint> points = new ArrayList<>();
        BufferedReader reader = new BufferedReader(new InputStreamReader(ClassLoader.getSystemResourceAsStream("iris_2d.csv")));

        String line;
        while ((line = reader.readLine()) != null) {
            String v[] = line.split(",");
            DataPoint point = new DataPoint(Double.parseDouble(v[0]), Double.parseDouble(v[1]));
            points.add(point);
        }

        reader.close();

        iris = new Dataset(points);
    }

    @Test
    public void varianceMinimizationTest() throws Exception {
        int k=5;

        Cluster[] clusters = ClusteringVarianceMinimization.varianceMinimization(iris, k);
        for (int i = 0; i < k; i++) {
            assertTrue(cluster5.contains(clusters[i]));
        }
    }

}